{% extends "base.html" %}
{% block page-style%}
<style>
.org{
    max-width: 200px;
}
.hidden{
    display:none;
};
</style>
{% endblock %}

{%block title%}
Wikilist - Contacts
{%endblock%}

{% block content %}
<div class="ui stackable grid">
    <div class="ui four wide column">

        <div class="ui vertical fluid accordion secondary menu">
            <h3 class="item">Categories</h3>
            {% for cat in categories %}
            <a href="/contacts?category={{cat.name}}"
               class="item {%ifequal filterby.category cat.name %}active{%endifequal%}">{{cat.name}}</a>
            {% endfor %}
        </div>

    </div>

    <div class="ui twelve wide column">



            <a href="/contacts/new{%if querystring%}?{{querystring}}{%endif%}"
               class="ui right floated labeled icon button">
                <i class="user plus icon"></i>
                Add Contact
            </a>


            <!-- Toolbar -->
            <div class="ui icon buttons">

                <!-- Delete selected button -->
                {% ifunequal identity.role "reader" %}
                <button class="ui icon button delete-button" title="Delete selected">
                    <i class="trash icon"></i>
                </button>
                {% endifunequal %}

                <!-- Export modal -->
                <div class="ui icon button export-button" title="Export selected as">
                    <i class="download icon"></i>
                    <div class="menu"></div>
                </div>

                <!-- Compose to button -->
                <button class="ui icon button email-button"
                        formmethod="POST"
                        formaction="/contacts/export/mailto"
                        type="submit"
                        form="all-form"
                        title="Compose to selected"
                        target="_blank">
                    <i class="mail icon"></i>
                </button>

                <!-- Filter button -->
                <!-- Uses a hack to show the message, it sends the hidden
                    filter form, with `filter` field set or it does nothing-->
                    <button class="ui icon button filter-button {%if filterby.filter%}active{%endif%}"
                        {%if not filterby.filter%}type="submit"{%else%}type="button"{%endif%}
                        title="Filter result"
                        formmethod="GET"
                        form="filter-form"
                        name="filter"
                        value="true">
                    <i class="filter icon"></i>
                </button>
                <!-- This is a worse way to implement it, but it also works,
                    just take the previous querystring and append filter=true
                    at the beginning
                <a class="ui icon button filter-button" title="Filter result"
                    href="/contacts/?{% if not filterby.filter %}filter=true&{%endif%}{{querystring}}">
                    <i class="filter icon"></i>
                </a>
                -->
            </div>

            <!-- Filter message -->
            <div class="ui secondary segment {%if not filterby.filter%}hidden{%endif%}" id="filter-message">
                {% include filter-form.html %}
            </div>


            <!-- Error/Success Messages -->
            {%if error%}
            <div class="ui error message">
                <div class="header">Errors occurred</div>
                <ul>
                    {% for key,value in error %}
                    <li>{{value}}</li>
                    {% endfor %}
                </ul>
            </div>
            {%endif%}

            {% if success %}
            <div class="ui success message">
                <div class="header">Success</div>
                <p>{{success}}</p>
            </div>
            {% endif %}


        <form class="{%if error%}error{%endif%} {%if success%}success{%endif%}" id="all-form">
            {% csrf-field %}
            <!-- Table view -->
            <table class="ui selectable stackable table">
                <thead>
                    <tr>
                        <th class="collapsing">
                            <div class="ui fitted checkbox">
                                <input type="checkbox" title="Select All" class="select-all">
                                <label></label>
                            </div>
                        </th>
                        <th class="org">Organization</th>
                        <th>Contact</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    {% for contact in contacts %}
                    <tr>
                        <td class="collapsing">
                            <div class="ui fitted checkbox">
                                <input type="checkbox" name="{{contact.id}}" class="select-contact">
                                <label></label>
                            </div>
                        </td>
                        <td class="org">
                            <h4>{{contact.organization|abbreviate:30}}</h4>
                        </td>
                        <td>
                            {% if contact.contact %}{{contact.contact}}{%endif%}
                            {% if contact.email %}
                            {% if contact.contact %} - {%endif%}<a href="mailto:{{contact.email}}">{{contact.email}}</a><br>
                            {%endif%}
                            {% if contact.phone %}<i>{{contact.phone}}</i>{%endif%}

                            {% include contact.html %}
                        </td>
                        <td class="collapsing right aligned">
                            <div class="ui icon buttons">
                                {% ifunequal identity.role "reader" %}
                                <a href="/contacts/{{contact.id}}"
                                   class="ui icon button"
                                   title="Edit contact">
                                    <i class="edit icon"></i>
                                </a>
                                {% endifunequal %}

                                <button data-target="{{contact.id}}" title="View contact" class="ui button view-contact">
                                    <i class="eye icon"></i>
                                </button>
                            </div>
                        </td>
                    </tr>
                    {% endfor %}
                    {% ifequal contacts|count 0%}
                    <tr>
                        <td></td>
                        <td><i>No contacts found</i></td>
                        <td></td>
                        <td></td>
                    </tr>
                    {%endifequal%}
                </tbody>
            </table>

        </form>


        <!-- Export format modal -->
        <div class="ui basic tiny modal" id="export-modal">
            <div class="ui icon header">
                <i class="download icon"></i>
                Export selected contacts as:
            </div>
            <!-- Select format menu -->
            <div class="content">
                <div class="ui vertical inverted menu fluid">
                    <button class="ui item basic approve inverted button fluid"
                            target="_blank"
                            formmethod="POST"
                            formaction="/contacts/export/csv"
                            type="submit"
                            form="all-form">
                        Comma separated values (CSV)
                    </button>
                    <button class="ui item basic approve inverted button fluid"
                            target="_blank"
                            formmethod="POST"
                            formaction="/contacts/export/vcard"
                            type="submit"
                            form="all-form">
                        Electronic business card (VCARD)
                    </button>
                    <button class="ui item basic approve inverted button fluid"
                            target="_blank"
                            formmethod="POST"
                            formaction="/contacts/export/print"
                            type="submit"
                            form="all-form">
                        Printable stickers
                    </button>
                </div>
            </div>
            <div class="actions">
                <button class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    Cancel
                </button>
            </div>
        </div>



        <!-- Confirm deletion modal -->
        {% ifunequal identity.role "reader" %}
        <div class="ui basic tiny modal" id="confirm-modal">
            <div class="ui icon header">
                <i class="trash icon"></i>
                Delete selected contacts
            </div>
            <div class="content">
                <p>Are you sure you want to delete selected contacts?</p>
            </div>
            <div class="actions">
                <button class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </button>
                <button class="ui basic approve inverted button"
                        id="delete-confirm"
                        formmethod="POST"
                        formaction="/contacts/{%if querystring%}?{{querystring}}{%endif%}"
                        form="all-form">
                    <i class="trash icon"></i>
                    Yes
                </button>
            </div>
        </div>
        {% endifunequal %}


    </div>
</div>
{% endblock %}

{% block page-scripts %}
<script>
    // Side menu accordion
    $('.ui.accordion').accordion();


    // Select all checkbox
    $('.select-all').change(function() {
        if(this.checked){
            $('.select-contact').prop('checked', true);
        } else {
            $('.select-contact').prop('checked', false);
        }
    });


    // Delete Selected
    $('.delete-button').on('click touch', function(e){
        e.preventDefault();
        $('#confirm-modal').modal('show');
    });

    // Open View Modals
    $('.ui.button.view-contact').on('click touch', function(e){
        e.preventDefault();
        el = $(e.currentTarget);
        $('#'+el.attr("data-target")).modal('show');
    });


    // Export Selected
    $('.export-button').on('click touch', function(e){
        e.preventDefault();
        $('#export-modal').modal('show');
    });

    // Filter form fields
    $('#language, #category, #organization')
    .dropdown({
        maxSelections: 1,
    });
    // Restores to the latest values
    $('#restore-filter')
    .on("click touch", function(){
        $('#language, #category, #organization')
        .dropdown("restore defaults");
    })
    // Clears filter and exit, it maintains the category because it can be 
    // controlled with the menu in the left side.
    $('#close-filter')
    .on("click touch", function(ev){
        $('#language, #organization')
        .dropdown("clear");
        $('#filter-form').submit();
    })
</script>
{% endblock %}
